
/******************************************************************/
/* JavaScript-Programm zur Berechnung des Benzinverbrauchs von KFZ */
/* Autor: Martin Dietze                                           */
/* 10.03.2019                                                     */
/******************************************************************/

var m, s, cw, h, Wv, Wr, Wl, Wh, Wges, A, liter, wigr, anz, mu, factor;
var Wvproz, Wrproz, Wlproz, Whproz;
var g=9.81, ro=1.3;  // Erdbeschleunigung, Dichte der Luft

function ktp(x) {    // wandelt Komma in Punkt,
  var y = "";        // somit werden auch deutsche Kommazahlen akzeptiert
  var xx = x.split("");
  for(i in xx) {
    if(xx[i] == ',')
      xx[i] = '.';
    y += xx[i];
  }
  y = y*1;
  return y;
}

function runden(x) {  // rundet x auf 2 Nachkommastellen
  x = Math.round(x*100);
  x = x/100;
  return x;
}

function nan(x) {    // ersetzt NaN durch 0
  if(isNaN(x))
    x = "0";
  return x;
}

function balken() {  // berechnet Balkenlngen
  document.form1.anfahrb.width = 300*(Wv/Wges);
  document.form1.rollwidb.width = 300*(Wr/Wges);
  document.form1.luftwidb.width = 300*(Wl/Wges);
  document.form1.hoehenb.width = 300*(Wh/Wges);
  if(Wges == 0 || isNaN(Wges))
    document.form1.gesamtb.width = 0;  // grauer Balken fr 100%
  else
    document.form1.gesamtb.width = 300;
}

function eingabe() {  // speichert Inhalte der Eingabefelder in Variablen
  m = ktp(document.form1.masse.value);    // Fahrzeugmasse in kg
  A = ktp(document.form1.querschn.value); // Querschnittsflche in m2
  cw = ktp(document.form1.cwwert.value);  // cw-Wert
  mu = ktp(document.form1.rollwid.value); // Rollwiderstandsbeiwert
  v = ktp(document.form1.geschw.value);   // Geschwindigkeit in km/h
  v = v*0.2778;                           // Umrechnung von km/h in m/s
  s = ktp(document.form1.weg.value);      // Wegstrecke in km
  s = s*1000;                             // Umrechnung von km in m
  h = ktp(document.form1.hoehe.value);    // Hhendiff. in m
  wigr = ktp(document.form1.wgrad.value); // Wirkungsgrad in %
  anz = ktp(document.form1.anzst.value);  // Anzahl Start-Stopps
  
}

factor = 3.15e5;        // zur Umrechnung von Ws in Liter Benzin          
						// 1 Liter Benzin hat einen Brennwert von 31,5 MJ
						// Wirkungsgrad = Prozent / 100
						// damit: factor = (31,5 * 10^6) / 100 = 3,15 * 10^5


function beschlArb() {
  Wv = 0.5*m*v*v*anz;   // Arbeit in Ws
  Wv /=(wigr*factor);   // Umrechnung in Liter Benzin
  Wv = runden(Wv);
}
function rollWid() {
  Wr = mu*m*g*s;
  Wr /=(wigr*factor);
  Wr = runden(Wr);
}
function luftWid() {
  Wl = 0.5*cw*A*ro*v*v*s;
  Wl /=(wigr*factor);           
  Wl = runden(Wl);
}
function hubArb() {
  Wh = m*g*h;
  Wh /=(wigr*factor);
  Wh = runden(Wh);
}
function berechnen() {
  eingabe();
  beschlArb();
  rollWid();
  luftWid();
  hubArb();

  Wges = Wv+Wr+Wl+Wh;
  Wges = runden(Wges);

  document.form1.wv.value = nan(Wv);
  document.form1.wr.value = nan(Wr);
  document.form1.wl.value = nan(Wl);
  document.form1.wh.value = nan(Wh);
  document.form1.wges.value = nan(Wges);

  balken();
}

function reset_balken() {
  document.form1.anfahrb.width = 0;
  document.form1.rollwidb.width = 0;
  document.form1.luftwidb.width = 0;
  document.form1.hoehenb.width = 0;
  document.form1.gesamtb.width = 0;
}

function _reset() {       // fr Button Vorgabe
  document.form1.masse.value = 1200;
  document.form1.querschn.value = 2.0;
  document.form1.cwwert.value = 0.3;
  document.form1.rollwid.value = 0.02;
  document.form1.geschw.value = 100;
  document.form1.weg.value = 100;
  document.form1.hoehe.value = 0;
  document.form1.wgrad.value = 25;
  document.form1.anzst.value = 1;

  reset_balken();
}

/******** end of program ***********/